//
// (c) 2019 Jan Uhrin, OM2JU
//
// Using external libraries; original autor comments included
//----------------------------------------------------------------------------------
//
// Rounded primitives for openscad
// (c) 2013 Wouter Robers 

// Syntax example for a rounded block
//translate([-15,0,10]) rcube([20,20,20],2);

// Syntax example for a rounded cylinder
//translate([15,0,10]) rcylinder(r1=15,r2=10,h=20,b=2);

$fn = 16;

//----------------------------------------------------------------------------------
module rcube(Size=[20,20,20],b=2)
{hull(){for(x=[-(Size[0]/2-b),(Size[0]/2-b)]){for(y=[-(Size[1]/2-b),(Size[1]/2-b)]){for(z=[-(Size[2]/2-b),(Size[2]/2-b)]){ translate([x,y,z]) sphere(b);}}}}}


module rcylinder(r1=10,r2=10,h=10,b=2)
{translate([0,0,-h/2]) hull(){rotate_extrude() translate([r1-b,b,0]) circle(r = b); rotate_extrude() translate([r2-b, h-b, 0]) circle(r = b);}}

//----------------------------------------------------------------------------------

$kh = 10;  // knob height


difference() {
translate([0,0,$kh/2]) rcylinder(r1=35/2,r2=35/2,h=$kh,b=2.0);
small_knob();
translate([0, 0, 1])   linear_extrude(height = 35) circle(6.1/2);
}

translate([0,3/2+1.6,$kh/2]) cube(size=[8,3,$kh],center=true);  


module small_knob () {
difference() {
translate([0,0,$kh/2+4]) rcylinder(r1=28/2,r2=28/2,h=$kh+2,b=2.0);
translate([0,0,$kh/2]) rcylinder(r1=13/2,r2=13/2,h=$kh+2,b=2.0);
}
}
