//----------------------------------------------------------------------------------
//
// 
// 
// (c) 2019 Jan Uhrin, OM2JU
//
//
$fn = 32;    // Rounding parameter; for production set to high (e.g. 40) 
//
//----------------------------------------------------------------------------------
//
// Rounded primitives for openscad
// (c) 2013 Wouter Robers 

// Syntax example for a rounded block
//translate([-15,0,10]) rcube([20,20,20],2);

// Syntax example for a rounded cylinder
//translate([15,0,10]) rcylinder(r1=15,r2=10,h=20,b=2);

module rcube(Size=[20,20,20],b=2)
{hull(){for(x=[-(Size[0]/2-b),(Size[0]/2-b)]){for(y=[-(Size[1]/2-b),(Size[1]/2-b)]){for(z=[-(Size[2]/2-b),(Size[2]/2-b)]){ translate([x,y,z]) sphere(b);}}}}}


module rcylinder(r1=10,r2=10,h=10,b=2)
{translate([0,0,-h/2]) hull(){rotate_extrude() translate([r1-b,b,0]) circle(r = b); rotate_extrude() translate([r2-b, h-b, 0]) circle(r = b);}}
    
//----------------------------------------------------------------------------------

translate([0,70/2-1.0,5])    rcube(Size=[100,2,6],b=1);  
translate([0,-(70/2-1.0),5]) rcube(Size=[100,2,6],b=1);  

difference () {
  union () {
    translate([10+60-2.0,0,11/2+2])    rcube(Size=[2,20,11],b=1);  
    translate([-(10+60-2.0),0,11/2+2]) rcube(Size=[2,20,11],b=1);  
  }
// fixing holes for M3
rotate([0,90,0]) translate([-5-5,0,0])  cylinder(r1=2.9/2,r2=2.9/2,h=150,center=true);  
}

difference() {
// difference of two rounded cubes, creates shell like object
translate([0,0,50/2])   rcube(Size=[20+120+1.6,70+3,50],b=5);
translate([0,0,60/2+5]) rcube(Size=[20+120-1.6,70,60],b=2);  
translate([0,0,60/2+2]) rcube(Size=[20+120-8,70-8,60],b=2);  

// big cube from top to limit height
translate([0,0,70+5]) cube(size=[150,150,140],center=true);  



  for (j=[-20:5:20])  {
    for (i=[15:5:55])  {
      translate([i,j,0]) rcube(Size=[3,3,10],b=1);
    }
  }



// text
/*
rotate([0,180,180])
translate([ -17.0,5,4.0]) linear_extrude (height=10, center = true) text("design by", size=5.4, font="Helvetica:style=Bold");
rotate([0,180,180])
translate([ -17.0,-6,4.0]) linear_extrude (height=10, center = true) text("OM2JU", size=8.4, font="Courier:style=Bold");
*/

}



module M3hole () {
//difference () {
rotate([0,0,0]) translate([0,0,-31.6])  cylinder(r1=5.8/2,r2=5.8/2,h=40,center=true);  
rotate([0,0,0]) translate([0,0,0])  cylinder(r1=3.5/2,r2=3.5/2,h=41,center=true);  
//}
}
